# Author: Giam Teck Choon
# Modified by Michael Shinn for Other variants
# Creation Date: 01 May 2004 GMT +8
# Latest Version/Date: 07 May 2005

enabletls() {
	if [ -d /lib/tls.disabled ] ; then
		if [ -d /lib/tls ] ; then
			notfound=0
			for i in `ls /lib/tls`; do
				if [ ! -f /lib/tls.disabled/${i} ] ; then
					notfound=1
				fi
			done
			if [ "$notfound" -eq 1 ] ; then
				rm -rf /lib/tls.disabled
			else
				mv /lib/tls.disabled /lib/tls.disabled-`date +%F-%H-%m-%s`
			fi
		else
			mv /lib/tls.disabled /lib/tls
		fi
	fi
}

disabletls() {
	if [ -d /lib/tls ] ; then
		# Fix for future glibc package update on /lib/tls
		if [ -d /lib/tls.disabled ] ; then
			notfound=0
			for i in `ls /lib/tls`; do
				if [ ! -f /lib/tls.disabled/${i} ] ; then
					notfound=1
				fi
			done
			if [ "$notfound" -eq 1 ] ; then
				rm -rf /lib/tls.disabled
			else
				mv /lib/tls.disabled /lib/tls.disabled-`date +%F-%H-%m-%s`
			fi
		fi
		mv /lib/tls /lib/tls.disabled
	fi
}

# check to see whether are you root
if [ `whoami` == "root" ] ; then

	# getconf GNU_LIBPTHREAD_VERSION
	libthreadversion=`getconf GNU_LIBPTHREAD_VERSION`
	# check for libthread version
	checklibthreadversion=`echo ${libthreadversion} | grep 'NPTL'`
	# grep for if booted kernel is RHEL by the word 'E'
	isstockkernel=`uname -r | grep 'E'`
	if [ -f /etc/redhat-release ] ; then
		redhatversion=`cat /etc/redhat-release`
	else
		redhatversion=''
	fi
	# grep for 'Red Hat Enterprise Linux'
	checkrhel=`echo ${redhatversion} | grep 'Red Hat Enterprise Linux'`
	# grep for 'CentOS'
	checkcentos=`echo ${redhatversion} | grep 'CentOS'`
	# grep for Whitebox
	checkwhitebox=`echo ${redhatversion} | grep 'White Box Enterprise Linux'`
	# If the booted kernel is not one of the stock kernel or it is custom vanilla kernel
	if [ ! -n "$isstockkernel" ] ; then
		# check whether it is RHEL or CentOS
		if [ -n "$checkrhel" ] || [ -n "$checkcentos" ] || [ -n "$checkwhitebox" ] ; then
			disabletls
			export LD_ASSUME_KERNEL=2.4
		fi
	# If the booted kernel is one of the stock kernel
	else
		# check whether it is RHEL or CentOS
		if [ -n "$checkrhel" ] || [ -n "$checkcentos" ] || [ -n "$checkwhitebox" ] ; then
			enabletls
			export LD_ASSUME_KERNEL=''
		fi
	fi
fi
